#include <ArduinoMqttClient.h>
#include <ESP8266WiFi.h>

String Rvalue;
String Rvalue2;
String Rvalue3;
///////please enter your sensitive data in the Secret tab/arduino_secrets.h
char ssid[] = "nome della rete WiFi";        // your network SSID (name)
char pass[] = "password di rete";   // your network password (use for WPA, or use as key for WEP)

WiFiClient wifiClient;
MqttClient mqttClient(wifiClient);

const char broker[] = "test.mosquitto.org";
int        port     = 1883;
const char MsG[]  = "real_unique_MsG";
const char MsG2[]  = "real_unique_MsG_2";
const char MsG3[]  = "real_unique_MsG_3";

//set interval for sending messages (milliseconds)
const long interval = 8000;
unsigned long previousMillis = 0;

int count = 0;

void setup() {
  //Initialize serial and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  // attempt to connect to Wifi network:
  Serial.print("Attempting to connect to WPA SSID: ");
  Serial.println(ssid);
  while (WiFi.begin(ssid, pass) != WL_CONNECTED) {
    // failed, retry
    Serial.print(".");
    delay(5000);
  }

  Serial.println("You're connected to the network");
  Serial.println();

  Serial.print("Attempting to connect to the MQTT broker: ");
  Serial.println(broker);

  if (!mqttClient.connect(broker, port)) {
    Serial.print("MQTT connection failed! Error code = ");
    Serial.println(mqttClient.connectError());

    while (1);
  }

  Serial.println("You're connected to the MQTT broker!");
  Serial.println();
}

void loop() {
  // call poll() regularly to allow the library to send MQTT keep alive which
  // avoids being disconnected by the broker
  mqttClient.poll();

  unsigned long currentMillis = millis();

  if (currentMillis - previousMillis >= interval) {
    // save the last time a message was sent
    previousMillis = currentMillis;

//Send Y or N reading valuues from GPIO0, GPIO13, GPIO14
    if (digitalRead(0) == 1) {
      //Rvalue = "N";
      Rvalue ="Switch_1 spento";
    }
    else {
      //Rvalue = "Y";
       Rvalue ="Switch_1 attivato";
    }
        if (digitalRead(13) == 0) {
      //Rvalue2 = "N";
      Rvalue2 ="Switch_2 spento";
    }
    else {
      //Rvalue2 = "Y";
      Rvalue2 ="Switch_2 attivato";
    }
        if (digitalRead(14) == 0) {
      //Rvalue3 = "N";
      Rvalue3 ="Switch_3 spento";
    }
    else {
      //Rvalue3 = "Y";
      Rvalue3 ="Switch_3 attivato";
    }
    
    //record random value from A0, GPIO13 and GPIO14
    //int Rvalue = analogRead(A0);
    //int Rvalue = digitalRead(0);
    //int Rvalue2 = digitalRead(13);
    //int Rvalue3 = digitalRead(14);

    Serial.print("Sending message to MsG: ");
    Serial.println(MsG);
    Serial.println(Rvalue);

    Serial.print("Sending message to MsG: ");
    Serial.println(MsG2);
    Serial.println(Rvalue2);

    Serial.print("Sending message to MsG: ");
    Serial.println(MsG3);
    Serial.println(Rvalue3);

    // send message, the Print interface can be used to set the message contents
    mqttClient.beginMessage(MsG);
    mqttClient.print(Rvalue);
    mqttClient.endMessage();

    mqttClient.beginMessage(MsG2);
    mqttClient.print(Rvalue2);
    mqttClient.endMessage();

    mqttClient.beginMessage(MsG3);
    mqttClient.print(Rvalue3);
    mqttClient.endMessage();

    Serial.println();
  }
}
